﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using SpeechLib;



namespace Text2Speech
{
    public partial class Text2Speech : Form
    {
        private SpVoice mVoice;
        private Thread mSpeechWorker;  



        public Text2Speech()
        {
            ArrayList lVoiceTypes = new ArrayList();
            ISpeechObjectTokens mVoices;
            int lCounter;

            InitializeComponent();

            mVoice = new SpVoice();
            mVoices = mVoice.GetVoices(null, null);

            for (lCounter = 0; lCounter < mVoices.Count; lCounter++)
                VoiceTypeComboBox.Items.Add(mVoices.Item(lCounter).GetDescription(0));

            VoiceTypeComboBox.SelectedIndex=0;
        }




        private void CloseButton_Click(object sender, EventArgs e)
        {
            Dispose();
        }




        private void SayItButton_Click(object sender, EventArgs e)
        {


            if (SayItButton.Text == "Stop")
            {
                stopTalking();
            }
            else
            {
                SayItButton.Text = "Stop";
                SayItButton.Enabled = false;
                CloseButton.Enabled = false;
                OutputTextBox.ReadOnly = true;
                VoiceTypeComboBox.Enabled = false;
                mVoice.Voice = mVoice.GetVoices("", "").Item(VoiceTypeComboBox.SelectedIndex);


                /*
                 * Make sure no other thread is running
                 * 
                 */

                if (mSpeechWorker != null && mSpeechWorker.IsAlive)
                {
                    mSpeechWorker.Abort();
                    mSpeechWorker.Join();
                }

                SayItButton.Enabled = true;
                mSpeechWorker = new Thread(new ThreadStart(startTalking));
                mSpeechWorker.IsBackground = true;
                mSpeechWorker.Start();
            }

        }


        private void startTalking()
        {
            mVoice.Speak(OutputTextBox.Text, SpeechVoiceSpeakFlags.SVSFlagsAsync);

            // It happened the state was not set to "running" and it jumpted
            // directly to stopTalking(). Ideas how to solve it or handle
            // it the right way? :/
            Thread.Sleep(200);
            while (mVoice.Status.RunningState == SpeechLib.SpeechRunState.SRSEIsSpeaking)
            {
                Thread.Sleep(100);
            }
            this.Invoke((MethodInvoker)delegate() { stopTalking(); });
        }



        private void stopTalking()
        {

            if (mVoice.Status.RunningState == SpeechLib.SpeechRunState.SRSEIsSpeaking)
            {
                mVoice.Speak(null, SpeechVoiceSpeakFlags.SVSFPurgeBeforeSpeak);
            }

            if (mSpeechWorker != null && mSpeechWorker.IsAlive)
            {
                mSpeechWorker.Abort();
                mSpeechWorker.Join();
            }


            SayItButton.Text = "Say it";
            CloseButton.Enabled = true;
            VoiceTypeComboBox.Enabled = true;
            OutputTextBox.ReadOnly = false;
        }


        private void VolumeTrackBar_ValueChanged(object sender, EventArgs e)
        {
            mVoice.Volume = VolumeTrackBar.Value * 10;
        }

        private void trackBar1_ValueChanged(object sender, EventArgs e)
        {
            mVoice.Rate = RateTrackBar.Value;
        }
    }
}
